#region Copyright Syncfusion Inc. 2001 - 2012
//
//  Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;

namespace EssentialDocIOSamples
{

    public class Form1 : System.Windows.Forms.Form
    {
        #region Private Members

        private ToolTip toolTip1;
        private Button button1;
        private PictureBox pictureBox1;
        private Label descriptionLabel;
        private GroupBox groupBox1;
        private RadioButton bmpRadioBtn;
        private RadioButton emfRadioBtn;
        private RadioButton pngRadioBtn;
        private RadioButton jpegRadioBtn;
        private Button button2;
        private TextBox textBox;
        private IContainer components;
        private System.Windows.Forms.OpenFileDialog openFileDialog = new OpenFileDialog();
        String filePath;
        private readonly BackgroundWorker worker = new BackgroundWorker();
        Image[] images;
        WordDocument wordDoc;
        #endregion

        #region Constructor, Main and Dispose
        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            Application.EnableVisualStyles();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }
        #endregion

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.button1 = new System.Windows.Forms.Button();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.descriptionLabel = new System.Windows.Forms.Label();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.bmpRadioBtn = new System.Windows.Forms.RadioButton();
            this.emfRadioBtn = new System.Windows.Forms.RadioButton();
            this.pngRadioBtn = new System.Windows.Forms.RadioButton();
            this.jpegRadioBtn = new System.Windows.Forms.RadioButton();
            this.button2 = new System.Windows.Forms.Button();
            this.textBox = new System.Windows.Forms.TextBox();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.BackColor = System.Drawing.Color.Transparent;
            this.button1.FlatAppearance.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(192)))), ((int)(((byte)(128)))));
            this.button1.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(224)))), ((int)(((byte)(192)))));
            this.button1.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
            this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.button1.Location = new System.Drawing.Point(370, 218);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(128, 55);
            this.button1.TabIndex = 62;
            this.button1.Text = "Convert To Image";
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // pictureBox1
            // 
            this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(0, 0);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(510, 142);
            this.pictureBox1.TabIndex = 60;
            this.pictureBox1.TabStop = false;
            // 
            // descriptionLabel
            // 
            this.descriptionLabel.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(161)));
            this.descriptionLabel.ForeColor = System.Drawing.SystemColors.ControlText;
            this.descriptionLabel.Location = new System.Drawing.Point(-4, 89);
            this.descriptionLabel.Name = "descriptionLabel";
            this.descriptionLabel.Size = new System.Drawing.Size(514, 53);
            this.descriptionLabel.TabIndex = 68;
            this.descriptionLabel.Text = "Clicking the button below will result in a Image being converted from word docume" +
    "nt using Essential DocIO";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.bmpRadioBtn);
            this.groupBox1.Controls.Add(this.emfRadioBtn);
            this.groupBox1.Controls.Add(this.pngRadioBtn);
            this.groupBox1.Controls.Add(this.jpegRadioBtn);
            this.groupBox1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.groupBox1.Location = new System.Drawing.Point(12, 203);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(336, 70);
            this.groupBox1.TabIndex = 103;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Convert To";
            // 
            // bmpRadioBtn
            // 
            this.bmpRadioBtn.AutoSize = true;
            this.bmpRadioBtn.Checked = true;
            this.bmpRadioBtn.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.bmpRadioBtn.Location = new System.Drawing.Point(253, 33);
            this.bmpRadioBtn.Name = "bmpRadioBtn";
            this.bmpRadioBtn.Size = new System.Drawing.Size(73, 25);
            this.bmpRadioBtn.TabIndex = 103;
            this.bmpRadioBtn.TabStop = true;
            this.bmpRadioBtn.Text = "BMP";
            this.bmpRadioBtn.UseVisualStyleBackColor = true;
            // 
            // emfRadioBtn
            // 
            this.emfRadioBtn.AutoSize = true;
            this.emfRadioBtn.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.emfRadioBtn.Location = new System.Drawing.Point(172, 33);
            this.emfRadioBtn.Name = "emfRadioBtn";
            this.emfRadioBtn.Size = new System.Drawing.Size(70, 25);
            this.emfRadioBtn.TabIndex = 46;
            this.emfRadioBtn.Text = "EMF";
            this.emfRadioBtn.UseVisualStyleBackColor = true;
            // 
            // pngRadioBtn
            // 
            this.pngRadioBtn.AutoSize = true;
            this.pngRadioBtn.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(161)));
            this.pngRadioBtn.Location = new System.Drawing.Point(10, 29);
            this.pngRadioBtn.Name = "pngRadioBtn";
            this.pngRadioBtn.Size = new System.Drawing.Size(72, 25);
            this.pngRadioBtn.TabIndex = 44;
            this.pngRadioBtn.Text = "PNG";
            this.pngRadioBtn.UseVisualStyleBackColor = true;
            // 
            // jpegRadioBtn
            // 
            this.jpegRadioBtn.AutoSize = true;
            this.jpegRadioBtn.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(161)));
            this.jpegRadioBtn.Location = new System.Drawing.Point(88, 33);
            this.jpegRadioBtn.Name = "jpegRadioBtn";
            this.jpegRadioBtn.Size = new System.Drawing.Size(78, 25);
            this.jpegRadioBtn.TabIndex = 45;
            this.jpegRadioBtn.Text = "JPEG";
            this.jpegRadioBtn.UseVisualStyleBackColor = true;
            // 
            // button2
            // 
            this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button2.BackColor = System.Drawing.Color.Transparent;
            this.button2.FlatAppearance.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(192)))), ((int)(((byte)(128)))));
            this.button2.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(224)))), ((int)(((byte)(192)))));
            this.button2.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
            this.button2.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.button2.Location = new System.Drawing.Point(370, 161);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(128, 36);
            this.button2.TabIndex = 104;
            this.button2.Text = "Choose File";
            this.button2.UseVisualStyleBackColor = false;
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // textBox
            // 
            this.textBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.textBox.Location = new System.Drawing.Point(12, 161);
            this.textBox.Name = "textBox";
            this.textBox.Size = new System.Drawing.Size(336, 30);
            this.textBox.TabIndex = 105;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(8, 19);
            this.BackColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(510, 303);
            this.Controls.Add(this.textBox);
            this.Controls.Add(this.button2);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.descriptionLabel);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.pictureBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Generate Word";
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        #region Button_Click Event
        private void button1_Click(object sender, System.EventArgs e)
        {
            //Loading Image for Progress
            this.descriptionLabel.Image = Image.FromFile(Application.StartupPath + @"\..\..\Data\Animation.gif");
            //DoWork for NonUITasks
            worker.DoWork += worker_DoWork;
            //DoWork for UITasks
            worker.RunWorkerCompleted += worker_RunWorkerCompleted;
            //Run the Worker
            worker.RunWorkerAsync();
        }
        #endregion

        private void button2_Click(object sender, EventArgs e)
        {
            openFileDialog.InitialDirectory = Application.StartupPath;
            openFileDialog.FileName = "";
            openFileDialog.Filter = "Word Document(*.doc *.docx *.rtf)|*.doc;*.docx;*.rtf";
            DialogResult result = openFileDialog.ShowDialog();

            if (result == DialogResult.OK)
            {
                this.textBox.Text = openFileDialog.SafeFileName;
                this.textBox.Tag = openFileDialog.FileName;
                filePath = (string)this.textBox.Tag;
            }
        }
        #region UITasks
        /// <summary>
        /// Run
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void worker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            if (images != null && images.Length >0)
            {
                int pageNumber = 0;
                //Save as Bitmap image
                if (bmpRadioBtn.Checked)
                {
                    for (int i = 0; i < images.Length; i++)
                    {
                        images[i].Save(@"WordToImage_" + ++pageNumber + ".bmp", ImageFormat.Bmp);
                    }
                    if (MessageBox.Show("Do you want to view the Image file?", "File has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
                    {
                        try
                        {
                            System.Diagnostics.Process.Start(@"WordToImage_1.bmp");
                            //Exit
                            this.Close();
                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine(ex.ToString());
                        }
                    }
                }
                //Save as PNG image
                else if (pngRadioBtn.Checked)
                {
                    for (int i = 0; i < images.Length; i++)
                    {
                        images[i].Save(@"WordToImage_" + ++pageNumber + ".png", ImageFormat.Png);
                    }
                    if (MessageBox.Show("Do you want to view the Image file?", "File has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
                    {
                        try
                        {
                            System.Diagnostics.Process.Start(@"WordToImage_1.png");
                            //Exit
                            this.Close();
                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine(ex.ToString());
                        }
                    }
                }
                //Save as JPEG image
                else if (jpegRadioBtn.Checked)
                {
                    for (int i = 0; i < images.Length; i++)
                    {
                        images[i].Save(@"WordToImage_" + ++pageNumber + ".jpeg", ImageFormat.Jpeg);
                    }
                    if (MessageBox.Show("Do you want to view the Image file?", "File has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
                    {
                        try
                        {
                            System.Diagnostics.Process.Start(@"WordToImage_1.jpeg");
                            //Exit
                            this.Close();
                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine(ex.ToString());
                        }
                    }
                }
                //Save as EMF image
                else if (emfRadioBtn.Checked)
                {
                    for (int i = 0; i < images.Length; i++)
                    {
                        MemoryStream stream = (MemoryStream)wordDoc.RenderAsImages(i, ImageFormat.Emf);
                        using (FileStream fstream = new FileStream(@"WordToImage_" + ++pageNumber + ".emf", FileMode.OpenOrCreate))
                        {
                            stream.WriteTo(fstream);
                        }
                    }
                    if (MessageBox.Show("Do you want to view the Image file?", "File has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
                    {
                        try
                        {
                            System.Diagnostics.Process.Start(@"WordToImage_1.emf");
                            //Exit
                            this.Close();
                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine(ex.ToString());
                        }
                    }
                }
            }
            else
            {
                MessageBox.Show("Browse a word document and click the button to convert as a Image.");
            }
        }
        #endregion

        # region NonUITasks
        /// <summary>
        /// Performin Non UI Tasks
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void worker_DoWork(object sender, DoWorkEventArgs e)
        {
            if (this.textBox.Text != string.Empty)
            {
                //Open the Word document
                wordDoc = new WordDocument(filePath);
                //convert the document to Image
                images = wordDoc.RenderAsImages(ImageType.Metafile);
                //Close the Word Document         
                wordDoc.Close();
                //sets the label Image to null
                this.descriptionLabel.Image = null;
            }
            else
            {
                MessageBox.Show("Browse a word document and click the button to convert as a Image.");
            }
        }
        #endregion
    }
}

